/*
    i2c-mainboard.c - Part of lm_sensors, Linux kernel modules for hardware
                monitoring
    Copyright (c) 1998, 1999  Frodo Looijaard <frodol@dds.nl> 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/* Not configurable as a module */

#include <linux/init.h>

#ifdef CONFIG_I2C_ALI1535
extern int i2c_ali1535_init(void);
#endif
#ifdef CONFIG_I2C_ALI15X3
extern int i2c_ali15x3_init(void);
#endif
#ifdef CONFIG_I2C_AMD756
extern int i2c_amd756_init(void);
#endif
#ifdef CONFIG_I2C_AMD8111
extern int amd8111_init(void);
#endif
#ifdef CONFIG_I2C_HYDRA
extern int i2c_hydra_init(void);
#endif
#ifdef CONFIG_I2C_I801
extern int i2c_i801_init(void);
#endif
#ifdef CONFIG_I2C_I810
extern int i2c_i810_init(void);
#endif
#ifdef CONFIG_I2C_ISA
extern int i2c_isa_init(void);
#endif
#ifdef CONFIG_I2C_KEYWEST
extern int i2c_keywest_init(void);
#endif
#ifdef CONFIG_I2C_PIIX4
extern int i2c_piix4_init(void);
#endif
#ifdef CONFIG_I2C_SAVAGE4
extern int i2c_savage4_init(void);
#endif
#ifdef CONFIG_I2C_SIS5595
extern int i2c_sis5595_init(void);
#endif
#ifdef CONFIG_I2C_SIS630
extern int i2c_sis630_init(void);
#endif
#ifdef CONFIG_I2C_SIS645
extern int i2c_sis645_init(void);
#endif
#ifdef CONFIG_I2C_TSUNAMI
extern int i2c_tsunami_init(void);
#endif
#ifdef CONFIG_I2C_VIA
extern int i2c_via_init(void);
#endif
#ifdef CONFIG_I2C_VIAPRO
extern int i2c_vt596_init(void);
#endif
#ifdef CONFIG_I2C_VOODOO3
extern int i2c_voodoo3_init(void);
#endif


int __init i2c_mainboard_init_all(void)
{
#ifdef CONFIG_I2C_ALI1535
	i2c_ali1535_init();
#endif
#ifdef CONFIG_I2C_ALI15X3
	i2c_ali15x3_init();
#endif
#ifdef CONFIG_I2C_AMD756
	i2c_amd756_init();
#endif
#ifdef CONFIG_I2C_AMD8111
	amd8111_init();
#endif
#ifdef CONFIG_I2C_HYDRA
	i2c_hydra_init();
#endif
#ifdef CONFIG_I2C_I801
	i2c_i801_init();
#endif
#ifdef CONFIG_I2C_I810
	i2c_i810_init();
#endif
#ifdef CONFIG_I2C_ISA
	i2c_isa_init();
#endif
#ifdef CONFIG_I2C_KEYWEST
	i2c_keywest_init();
#endif
#ifdef CONFIG_I2C_PIIX4
	i2c_piix4_init();
#endif
#ifdef CONFIG_I2C_SAVAGE4
	i2c_savage4_init();
#endif
#ifdef CONFIG_I2C_SIS5595
	i2c_sis5595_init();
#endif
#ifdef CONFIG_I2C_SIS630
	i2c_sis630_init();
#endif
#ifdef CONFIG_I2C_SIS645
	i2c_sis645_init();
#endif
#ifdef CONFIG_I2C_TSUNAMI
	i2c_tsunami_init();
#endif
#ifdef CONFIG_I2C_VIA
	i2c_via_init();
#endif
#ifdef CONFIG_I2C_VIAPRO
	i2c_vt596_init();
#endif
#ifdef CONFIG_I2C_VOODOO3
	i2c_voodoo3_init();
#endif

	return 0;
}
