#ifndef __LINUX_QUICKCAM_VV6410_H
#define __LINUX_QUICKCAM_VV6410_H

// I2C Address
#define VV6410_ADDR			0x20

#define VV6410_GAIN			0x24

// I2C Registers
#define VV6410_IDENT		0x00
#define VV6410_STATUS		0x02	// Status
#define VV6410_IMASK		0x04	// Interrupt mask
#define VV6410_REG06 		0x06
#define VV6410_REG08 		0x08
#define VV6410_REG0A 		0x0a
#define VV6410_REG0C 		0x0c
#define VV6410_REG0E 		0x0e
 
#define VV6410_REG10		0x10
#define VV6410_ADC_BITS		0x12
  
#define VV6410_STARTX		0x57
#define VV6410_STARTY	 	0x59
#define VV6410_WIDTH  		0x52
#define VV6410_HEIGHT 		0x61
 
#define VV6410_INTEGRATE	0x1c
 
#define VV6410_GAIN  		0x24

#define VV6410_SHUTTERL 	0x26
#define VV6410_SHUTTERH 	0x28
 
#define VV6410_REG2A  		0x2a
#define VV6410_REG2C  		0x2c

#define VV6410_CONFIG  		0x2e	// Configuration
#define VV6410_CONTROL 		0x10	// Setup0
 
#define VV6410_REG32  		0x32
#define VV6410_REG34  		0x34
#define VV6410_REG36  		0x36
#define VV6410_REG38  		0x38                                                        

#endif
