/*
 * linux/drivers/video/vmware/guest_os.h -- VMware SVGA Framebuffer Driver
 *
 * Copyright (c) 2002  Denis Oliver Kropp <dok@directfb.org>
 *
 *
 * Card specific code is based on XFree86's VMware driver.
 * Framebuffer framework code is based on code of neofb.
 *
 * This file is subject to the terms and conditions of the GNU General
 * Public License.  See the file COPYING in the main directory of this
 * archive for more details.
 *
 */

#ifndef _GUEST_OS_H_
#define _GUEST_OS_H_

#define GUEST_OS_BASE  0x5000

#define GUEST_OS_DOS        (GUEST_OS_BASE+1)
#define GUEST_OS_WIN31      (GUEST_OS_BASE+2)
#define GUEST_OS_WINDOWS95  (GUEST_OS_BASE+3)
#define GUEST_OS_WINDOWS98  (GUEST_OS_BASE+4)
#define GUEST_OS_WINDOWSME  (GUEST_OS_BASE+5)
#define GUEST_OS_NT         (GUEST_OS_BASE+6)
#define GUEST_OS_WIN2000    (GUEST_OS_BASE+7)
#define GUEST_OS_LINUX      (GUEST_OS_BASE+8)
#define GUEST_OS_OS2        (GUEST_OS_BASE+9)
#define GUEST_OS_OTHER      (GUEST_OS_BASE+10)
#define GUEST_OS_FREEBSD    (GUEST_OS_BASE+11)
#define GUEST_OS_WHISTLER   (GUEST_OS_BASE+12)


#endif 
