
/* -*- linux-c -*- */
/*
 *
 *   Copyright (c) International Business Machines  Corp., 2000
 *
 *   This program is free software;  you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY;  without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
 *   the GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program;  if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

/* linux/driver/evms/ldev_mgr.h
 *
 * EVMS - Local Device (Hard Drive) Manager
 *
 */

/* plugin feature ID */
#define EVMS_LOCAL_DEVICE_MANAGER_ID	1

/* plugin ioctl feature command defines */
#define LDEV_MGR_BROADCAST_IOCTL_CMD	1

/**
 * struct ldev_plugin_ioctl - ldev mgr direct ioctl packet definition
 * @disk_handle: 	handle identifying target disk
 * @cmd: 		ioctl cmd
 * @arg: 		ioctl argument
 *
 * local device manager direct ioctl packet definition
 **/
struct ldev_plugin_ioctl {
	u64 disk_handle;
	u32 cmd;
	ulong arg;
};
